﻿
namespace CellinxPInvokeTest
{
    using System;
    using System.Runtime.InteropServices;

    public static class NVSNetLib
    {
        [DllImport("NVSNetLib.dll")]
        public static extern IntPtr NETSESSION_Init(String _address, UInt16 _port, String _url, String _id, String _passwd, Byte _connectType);
    }

    public delegate void sendAudio(IntPtr _this, String _buf, UInt32 _size);
    public delegate int sendControl(IntPtr _this, UInt32 _type, String _buf, UInt32 _size);
    public delegate int close(IntPtr _this);
    public delegate int release(IntPtr _this);
    public delegate int doStateMachine(IntPtr _this);
    public delegate int select(IntPtr _this, UInt32 _sec, UInt32 _usec);

    [StructLayout(LayoutKind.Sequential)]
    public class CNetSession
    {
        public int status;
        public int fps;

        public UInt32 sequence;
        public UInt32 sec;
        public UInt32 usec;
        public Byte frameType;

        public UInt32 dataSize;
        public String recvData;

        public String winPosition;

        public int isVideo;
        public int isAudio;
        public int isPlayBackAudio;
        public int isConfig;

        public int isEvent;
        public int isEventVideo;

        public NSServerInfo serverInfo;

        public sendAudio sendAudio;
        public close close;
        public release release;
        public sendControl sendControl;
        public doStateMachine doStatMachine;
    }

    [StructLayout(LayoutKind.Sequential)]
    public class NSServerInfo
    {

        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
        public Byte[] cameraModel;     // "V20A"

        public Byte reserved;
        public Byte videoCount;         // video count
        public Byte audioCount;         // audio count 

        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 32)]
        public Byte[] serverName;     // server name
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 32)]
        public Byte[] channelName;    // channel name
        public Byte channelNumber;      // channel number 1 ~ 4


        public NSVideoInfo videoInfo;
        public NSAudioInfo audioInfo;
    }

    [StructLayout(LayoutKind.Sequential)]
    public class NSVideoInfo
    {
        public UInt32 encodingType;       // video compressor type.

        public Byte frameMode;          // how to encode video stream.
        public UInt32 fps;                // 1 ~ 30
        public Byte vbr;                // if 0, use the bitrate member for const bitrate else over zero, various bitrate.

        // Bitrate setting -- a unit : 1000 Kbps

        public UInt32 bitrate;            // bitrate in kilo bit per second
        public UInt16 videoWidth;         // frame width
        public UInt16 videoHeight;        // frame height

        public Byte videoStatus1;       // video signal
        public Byte videoStatus2;
        public Byte videoStatus3;
        public Byte videoStatus4;

        public Byte videoType;          // video output type
        public Byte groupSize;
    }

    [StructLayout(LayoutKind.Sequential)]
    public class NSAudioInfo
    {
        public UInt32 encodingType;       // "IPCM" IMA ACPCM, "MPCM" MS ADPCM, "NPCM" PCM
        public Byte channel;            // audio channel : Stereo(0x02), Mono(0x01)
        public Byte bitPerSample;       // 8 bit, 16 bit
        public UInt32 samplingRate;       // 8000, 11025, 16000, 22050, 44100, 48000
    }

    class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            var pointer = NVSNetLib.NETSESSION_Init("172.16.40.105", 1825, "172.16.40.105", "root", "pass", 0x01);
            var session = new CNetSession();

            unsafe
            {
                Marshal.PtrToStructure(pointer, session.GetType());
            }
        }
    }
}
